; ######################################################################### 

.386 
.model flat,stdcall 
include \masm32\include\windows.inc 
include \masm32\include\kernel32.inc 
includelib \masm\lib\kernel32.lib 

; ######################################################################### 

Split PROTO :BYTE,:DWORD,:WORD,:DWORD 

;-------------------------------------------------------------------------- 
; written by Nhr0M, August 21, y2k4 
; 
; Split(char,lpAsciiz,wNew,max_elements) 

; Procedure that splits a string into an array, based on a 
; delimiter character specified in the call. 
; Like that useful split() in perl :-) 
; 
; char = delimiter character (BYTE!) 
; lpAsciiz = pointer to your string 
; wNew = break original string (0) or leave it intact (1) 
; max_elements = maximum array items, or 0 if no bounds 
;-------------------------------------------------------------------------- 
; 
; [eax]-->|---------| 
; | number | <-- DWORD 
; |---------| 
; | . . . |-->'String1',0 
; | . . . |-->'String2',0 
; | . . . |\ 
; |_________|-\_____________| Array of DWORDs (pointers to strings) 
; 
;[eax]=size, [eax+4]=lpString1, ... 
;-------------------------------------------------------------------------- 
;Examples: assume that text='one:two:three',0 
; 
; invoke Split,':',addr text,1,NULL 
; 
; [eax]=3, [eax+4]=ptr1 ,[eax+8]=ptr2, [eax+12]=ptr3 
; [ptr1]='one',0 ; [ptr2]='two',0 ; [ptr3]='three',0 
; text='one:two:three',0 <-- ! Note that it's not changed 
; 
; invoke Split,':',addr text,1,2 
; 
; [eax]=2, . . . , [ptr1]='one',0 ; [ptr2]='two:three',0 
;-------------------------------------------------------------------------- 


.code 

Split PROC USES ebx edx esi edi char:BYTE,lpAsciiz:DWORD,wNew:WORD,max_elements:DWORD 
LOCAL hHeap:DWORD 

mov ebx,esp 
mov edi,lpAsciiz 
mov al,0 
xor ecx,ecx 
dec ecx 
repne scasb 
inc ecx 
neg ecx 
dec edi 
push ecx 
push ecx 
std 
mov edx,lpAsciiz 
cmp wNew,1 
jne @F 
invoke GetProcessHeap 
invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,ecx 
mov edx,eax 
@@: 
mov esi,edi 
mov edi,edx 
dec edi 
pop ecx 
add edi,ecx 
rep movsb 
pop ecx 
add edi,ecx 
mov al,char 
mov edx,max_elements 
dec edx 
@@: 
repne scasb 
test ecx,ecx 
je @F 
mov byte ptr [edi+1],0 
inc edi 
inc edi 
dec edx 
push edi 
dec edi 
test edx,edx 
jz @F 
dec edi 
jmp @B 
@@: 
inc edi 
push edi 
cld 
mov edx,ebx 
sub edx,esp 
push edx 
add edx,4 
invoke GetProcessHeap 
invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,edx 
mov ebx,eax 
pop eax 
mov ecx,eax 
add ecx,4 
shr eax,2 
push eax 
shl eax,2 

mov esi,esp 
mov edi,ebx 
rep movsb 
xchg eax,ebx 
add esp,ebx 
add esp,4 
;NB: You can easily modify this procedure to 
; return ``size'' in ebx or something... 
; ( mov ebx,[eax] <-- number of elements, now in ebx 
; mov eax,[eax+4] <-- eax now points to the {1st string} 
; ret ) 
ret 
Split endp
